USE [TechnoPower]
GO

/****** Object:  StoredProcedure [dbo].[rvlf_sp_AutomateDataMovement_335_Yearly]    Script Date: 22-Nov-2023 5.15.53 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROC [dbo].[rvlf_sp_AutomateDataMovement_335_Yearly]      
/*********************************************************************************************************      
Procedure Name : rvlf_sp_AutomateDataMovement      
Created By  :   
Created Date : 20-Nov-2023      
Description  : Data move from Live to backup database         
    
********************************************************************************************************/      
AS      
BEGIN      
SET NOCOUNT ON      
 
       
 DECLARE @rowCount VARCHAR(25)      
 DECLARE @bodytag VARCHAR(MAX) = ''      
 DECLARE @stExecutionTime DATETIME      
 DECLARE @endExecutionTime DATETIME      
       
 BEGIN TRY      
       
  SELECT @stExecutionTime = GETUTCDATE();      
        
  CREATE TABLE #tmpDataMovement_355      
  (      
   [Sno] [INT] IDENTITY(1,1) NOT NULL,      
   [MessageInID] [uniqueidentifier] NOT NULL,
	[BoxId] [varchar](15) NOT NULL,
	[OriginDateTime] [datetime] NOT NULL,
	[DateTimeReceived] [datetime] NOT NULL,
	[BoxMsgInTypeId] [tinyint] NULL,
	[CommInfo1] [varchar](15) NULL,
	[CommInfo2] [int] NULL,
	[ValidGps] [smallint] NULL,
	[Latitude] [decimal](10, 6) NULL,
	[Longitude] [decimal](10, 6) NULL,
	[Speed] [tinyint] NULL,
	[Heading] [smallint] NULL,
	[CustomProp] [varchar](2000) NULL,
	[StreetAddress] [varchar](250) NULL,
	[SequenceNum] [bigint] NULL,
	[IsArmed] [bit] NULL,
	[IsProcessed] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ControllerID] [varchar](50) NULL,
	[Alarm] [bit] NULL,
	[S1_Tot_Watts] [float] NULL,
	[S1_Tot_VA] [float] NULL,
	[S1_Tot_VAr] [float] NULL,
	[S1_KWh] [float] NULL,
	[S1_KVAh] [float] NULL,
	[S1_KVArh] [float] NULL,
	[S1_Freq] [float] NULL,
	[S1_AvgPF] [float] NULL,
	[S1_L1_PF] [float] NULL,
	[S1_L1_VAr] [float] NULL,
	[S1_L1_VA] [float] NULL,
	[S1_L1_Watts] [float] NULL,
	[S1_L1_Current] [float] NULL,
	[S1_L2_PF] [float] NULL,
	[S1_L2_VAr] [float] NULL,
	[S1_L2_VA] [float] NULL,
	[S1_L2_Watts] [float] NULL,
	[S1_L2_Current] [float] NULL,
	[S1_L3_PF] [float] NULL,
	[S1_L3_VAr] [float] NULL,
	[S1_L3_VA] [float] NULL,
	[S1_L3_Watts] [float] NULL,
	[S1_L3_Current] [float] NULL,
	[S2_Tot_Watts] [float] NULL,
	[S2_Tot_VA] [float] NULL,
	[S2_Tot_VAr] [float] NULL,
	[S2_KWh] [float] NULL,
	[S2_KVAh] [float] NULL,
	[S2_KVArh] [float] NULL,
	[S2_Freq] [float] NULL,
	[S2_AvgPF] [float] NULL,
	[S2_L1_PF] [float] NULL,
	[S2_L1_VAr] [float] NULL,
	[S2_L1_VA] [float] NULL,
	[S2_L1_Watts] [float] NULL,
	[S2_L1_Current] [float] NULL,
	[S2_L2_PF] [float] NULL,
	[S2_L2_VAr] [float] NULL,
	[S2_L2_VA] [float] NULL,
	[S2_L2_Watts] [float] NULL,
	[S2_L2_Current] [float] NULL,
	[S2_L3_PF] [float] NULL,
	[S2_L3_VAr] [float] NULL,
	[S2_L3_VA] [float] NULL,
	[S2_L3_Watts] [float] NULL,
	[S2_L3_Current] [float] NULL,
	[Main_Gen_LNVolt] [float] NULL,
	[Gen_LLVolt] [float] NULL,
	[GateWayID] [bigint] NULL,
	[ComMode] [nvarchar](50) NULL,
	[Digital_IP] [varchar](50) NULL,
	[Digital_OP] [varchar](50) NULL,
	[S1_L1_N_Voltage] [float] NULL,
	[S1_L2_N_Voltage] [float] NULL,
	[S1_L3_N_Voltage] [float] NULL,
	[S1_L1_L2_Voltage] [float] NULL,
	[S1_L2_L3_Voltage] [float] NULL,
	[S1_L3_L1_Voltage] [float] NULL,
	[S2_L1_N_Voltage] [float] NULL,
	[S2_L2_N_Voltage] [float] NULL,
	[S2_L3_N_Voltage] [float] NULL,
	[S2_L1_L2_Voltage] [float] NULL,
	[S2_L2_L3_Voltage] [float] NULL,
	[S2_L3_L1_Voltage] [float] NULL,
	[S1_LN_Volt] [float] NULL,
	[S1_LL_Volt] [float] NULL,
	[S2_LN_Volt] [float] NULL,
	[S2_LL_Volt] [float] NULL,      
   CONSTRAINT pk_tmpDataMovement_355_MessageInId PRIMARY KEY(Sno,MessageInID)      
  )      
        
  INSERT INTO #tmpDataMovement_355(MessageInID,BoxId,OriginDateTime,DateTimeReceived,BoxMsgInTypeId,CommInfo1,CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,CustomProp
,StreetAddress,SequenceNum,IsArmed,IsProcessed,IsArchived,ControllerID,Alarm,S1_Tot_Watts,S1_Tot_VA,S1_Tot_VAr,S1_KWh,S1_KVAh,S1_KVArh,S1_Freq
,S1_AvgPF,S1_L1_PF,S1_L1_VAr,S1_L1_VA,S1_L1_Watts,S1_L1_Current,S1_L2_PF,S1_L2_VAr,S1_L2_VA,S1_L2_Watts,S1_L2_Current,S1_L3_PF,S1_L3_VAr,S1_L3_VA
,S1_L3_Watts,S1_L3_Current,S2_Tot_Watts,S2_Tot_VA,S2_Tot_VAr,S2_KWh,S2_KVAh,S2_KVArh,S2_Freq,S2_AvgPF,S2_L1_PF,S2_L1_VAr,S2_L1_VA,S2_L1_Watts,S2_L1_Current
,S2_L2_PF,S2_L2_VAr,S2_L2_VA,S2_L2_Watts,S2_L2_Current,S2_L3_PF,S2_L3_VAr,S2_L3_VA,S2_L3_Watts,S2_L3_Current,Main_Gen_LNVolt,Gen_LLVolt,GateWayID,ComMode
,Digital_IP,Digital_OP,S1_L1_N_Voltage,S1_L2_N_Voltage,S1_L3_N_Voltage,S1_L1_L2_Voltage,S1_L2_L3_Voltage,S1_L3_L1_Voltage,S2_L1_N_Voltage
,S2_L2_N_Voltage,S2_L3_N_Voltage,S2_L1_L2_Voltage,S2_L2_L3_Voltage,S2_L3_L1_Voltage,S1_LN_Volt,S1_LL_Volt,S2_LN_Volt,S2_LL_Volt) 

     
  SELECT MessageInID,BoxId,OriginDateTime,DateTimeReceived,BoxMsgInTypeId,CommInfo1,CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,CustomProp
,StreetAddress,SequenceNum,IsArmed,IsProcessed,IsArchived,ControllerID,Alarm,S1_Tot_Watts,S1_Tot_VA,S1_Tot_VAr,S1_KWh,S1_KVAh,S1_KVArh,S1_Freq
,S1_AvgPF,S1_L1_PF,S1_L1_VAr,S1_L1_VA,S1_L1_Watts,S1_L1_Current,S1_L2_PF,S1_L2_VAr,S1_L2_VA,S1_L2_Watts,S1_L2_Current,S1_L3_PF,S1_L3_VAr,S1_L3_VA
,S1_L3_Watts,S1_L3_Current,S2_Tot_Watts,S2_Tot_VA,S2_Tot_VAr,S2_KWh,S2_KVAh,S2_KVArh,S2_Freq,S2_AvgPF,S2_L1_PF,S2_L1_VAr,S2_L1_VA,S2_L1_Watts,S2_L1_Current
,S2_L2_PF,S2_L2_VAr,S2_L2_VA,S2_L2_Watts,S2_L2_Current,S2_L3_PF,S2_L3_VAr,S2_L3_VA,S2_L3_Watts,S2_L3_Current,Main_Gen_LNVolt,Gen_LLVolt,GateWayID,ComMode
,Digital_IP,Digital_OP,S1_L1_N_Voltage,S1_L2_N_Voltage,S1_L3_N_Voltage,S1_L1_L2_Voltage,S1_L2_L3_Voltage,S1_L3_L1_Voltage,S2_L1_N_Voltage
,S2_L2_N_Voltage,S2_L3_N_Voltage,S2_L1_L2_Voltage,S2_L2_L3_Voltage,S2_L3_L1_Voltage,S1_LN_Volt,S1_LL_Volt,S2_LN_Volt,S2_LL_Volt               
  FROM rvlfMsgInHst_Techno_355 h WHERE h.IsArchived=0   
      
  --SELECT MessageInID,BoxId,OriginDateTime,DateTimeReceived,ServiceID,BoxMsgInTypeId,BoxProtocolTypeId,CommInfo1,      
  --CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,SensorMask,CustomProp,StreetAddress,SequenceNum,IsArmed,      
  --NearestLandmark,Priority,IsNotificationSent,LandMarkID,IsProcessed,odometer,duration,StreetAddress_AR,RoadSpeedLimit,RoadType,StreetAddress_Hin      
  --FROM #tmpDataMovement_FMS WHERE Sno > 0      
      
  --SELECT * FROM FMS_ARCHIVE.dbo.rvlfMsgInHst WHERE MessageInId IN (Select MessageInId FROM #tmpDataMovement_FMS WHERE Sno > 0)      

DECLARE @ptablename VARCHAR(max) = 'rvlfMsgInHst_Techno_355_'+ cast(year(getdate()) as varchar(4))
Declare @sql varchar(max)
IF NOT EXISTS ( SELECT TABLE_NAME FROM Technopower_Archive.INFORMATION_SCHEMA.tables  WHERE TABLE_NAME = @ptablename )  
BEGIN   
set @sql=N'CREATE TABLE Technopower_Archive.dbo.'+@ptablename+'(
[MessageInID] [uniqueidentifier] NOT NULL,
	[BoxId] [varchar](15) NOT NULL,
	[OriginDateTime] [datetime] NOT NULL,
	[DateTimeReceived] [datetime] NOT NULL,
	[BoxMsgInTypeId] [tinyint] NULL,
	[CommInfo1] [varchar](15) NULL,
	[CommInfo2] [int] NULL,
	[ValidGps] [smallint] NULL,
	[Latitude] [decimal](10, 6) NULL,
	[Longitude] [decimal](10, 6) NULL,
	[Speed] [tinyint] NULL,
	[Heading] [smallint] NULL,
	[CustomProp] [varchar](2000) NULL,
	[StreetAddress] [varchar](250) NULL,
	[SequenceNum] [bigint] NULL,
	[IsArmed] [bit] NULL,
	[IsProcessed] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ControllerID] [varchar](50) NULL,
	[Alarm] [bit] NULL,
	[S1_Tot_Watts] [float] NULL,
	[S1_Tot_VA] [float] NULL,
	[S1_Tot_VAr] [float] NULL,
	[S1_KWh] [float] NULL,
	[S1_KVAh] [float] NULL,
	[S1_KVArh] [float] NULL,
	[S1_Freq] [float] NULL,
	[S1_AvgPF] [float] NULL,
	[S1_L1_PF] [float] NULL,
	[S1_L1_VAr] [float] NULL,
	[S1_L1_VA] [float] NULL,
	[S1_L1_Watts] [float] NULL,
	[S1_L1_Current] [float] NULL,
	[S1_L2_PF] [float] NULL,
	[S1_L2_VAr] [float] NULL,
	[S1_L2_VA] [float] NULL,
	[S1_L2_Watts] [float] NULL,
	[S1_L2_Current] [float] NULL,
	[S1_L3_PF] [float] NULL,
	[S1_L3_VAr] [float] NULL,
	[S1_L3_VA] [float] NULL,
	[S1_L3_Watts] [float] NULL,
	[S1_L3_Current] [float] NULL,
	[S2_Tot_Watts] [float] NULL,
	[S2_Tot_VA] [float] NULL,
	[S2_Tot_VAr] [float] NULL,
	[S2_KWh] [float] NULL,
	[S2_KVAh] [float] NULL,
	[S2_KVArh] [float] NULL,
	[S2_Freq] [float] NULL,
	[S2_AvgPF] [float] NULL,
	[S2_L1_PF] [float] NULL,
	[S2_L1_VAr] [float] NULL,
	[S2_L1_VA] [float] NULL,
	[S2_L1_Watts] [float] NULL,
	[S2_L1_Current] [float] NULL,
	[S2_L2_PF] [float] NULL,
	[S2_L2_VAr] [float] NULL,
	[S2_L2_VA] [float] NULL,
	[S2_L2_Watts] [float] NULL,
	[S2_L2_Current] [float] NULL,
	[S2_L3_PF] [float] NULL,
	[S2_L3_VAr] [float] NULL,
	[S2_L3_VA] [float] NULL,
	[S2_L3_Watts] [float] NULL,
	[S2_L3_Current] [float] NULL,
	[Main_Gen_LNVolt] [float] NULL,
	[Gen_LLVolt] [float] NULL,
	[GateWayID] [bigint] NULL,
	[ComMode] [nvarchar](50) NULL,
	[Digital_IP] [varchar](50) NULL,
	[Digital_OP] [varchar](50) NULL,
	[S1_L1_N_Voltage] [float] NULL,
	[S1_L2_N_Voltage] [float] NULL,
	[S1_L3_N_Voltage] [float] NULL,
	[S1_L1_L2_Voltage] [float] NULL,
	[S1_L2_L3_Voltage] [float] NULL,
	[S1_L3_L1_Voltage] [float] NULL,
	[S2_L1_N_Voltage] [float] NULL,
	[S2_L2_N_Voltage] [float] NULL,
	[S2_L3_N_Voltage] [float] NULL,
	[S2_L1_L2_Voltage] [float] NULL,
	[S2_L2_L3_Voltage] [float] NULL,
	[S2_L3_L1_Voltage] [float] NULL,
	[S1_LN_Volt] [float] NULL,
	[S1_LL_Volt] [float] NULL,
	[S2_LN_Volt] [float] NULL,
	[S2_LL_Volt] [float] NULL
PRIMARY KEY CLUSTERED 
(
	[MessageInID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]'
--select len(@sql),@sql
EXEC (@sql)  
END 
DECLaRE @InsertQry varchar(max)= N'INSERT INTO Technopower_Archive.dbo.'+@ptablename+'    
  (MessageInID,BoxId,OriginDateTime,DateTimeReceived,BoxMsgInTypeId,CommInfo1,CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,CustomProp
,StreetAddress,SequenceNum,IsArmed,IsProcessed,IsArchived,ControllerID,Alarm,S1_Tot_Watts,S1_Tot_VA,S1_Tot_VAr,S1_KWh,S1_KVAh,S1_KVArh,S1_Freq
,S1_AvgPF,S1_L1_PF,S1_L1_VAr,S1_L1_VA,S1_L1_Watts,S1_L1_Current,S1_L2_PF,S1_L2_VAr,S1_L2_VA,S1_L2_Watts,S1_L2_Current,S1_L3_PF,S1_L3_VAr,S1_L3_VA
,S1_L3_Watts,S1_L3_Current,S2_Tot_Watts,S2_Tot_VA,S2_Tot_VAr,S2_KWh,S2_KVAh,S2_KVArh,S2_Freq,S2_AvgPF,S2_L1_PF,S2_L1_VAr,S2_L1_VA,S2_L1_Watts,S2_L1_Current
,S2_L2_PF,S2_L2_VAr,S2_L2_VA,S2_L2_Watts,S2_L2_Current,S2_L3_PF,S2_L3_VAr,S2_L3_VA,S2_L3_Watts,S2_L3_Current,Main_Gen_LNVolt,Gen_LLVolt,GateWayID,ComMode
,Digital_IP,Digital_OP,S1_L1_N_Voltage,S1_L2_N_Voltage,S1_L3_N_Voltage,S1_L1_L2_Voltage,S1_L2_L3_Voltage,S1_L3_L1_Voltage,S2_L1_N_Voltage
,S2_L2_N_Voltage,S2_L3_N_Voltage,S2_L1_L2_Voltage,S2_L2_L3_Voltage,S2_L3_L1_Voltage,S1_LN_Volt,S1_LL_Volt,S2_LN_Volt,S2_LL_Volt) 

  SELECT MessageInID,BoxId,OriginDateTime,DateTimeReceived,BoxMsgInTypeId,CommInfo1,CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,CustomProp
,StreetAddress,SequenceNum,IsArmed,IsProcessed,IsArchived,ControllerID,Alarm,S1_Tot_Watts,S1_Tot_VA,S1_Tot_VAr,S1_KWh,S1_KVAh,S1_KVArh,S1_Freq
,S1_AvgPF,S1_L1_PF,S1_L1_VAr,S1_L1_VA,S1_L1_Watts,S1_L1_Current,S1_L2_PF,S1_L2_VAr,S1_L2_VA,S1_L2_Watts,S1_L2_Current,S1_L3_PF,S1_L3_VAr,S1_L3_VA
,S1_L3_Watts,S1_L3_Current,S2_Tot_Watts,S2_Tot_VA,S2_Tot_VAr,S2_KWh,S2_KVAh,S2_KVArh,S2_Freq,S2_AvgPF,S2_L1_PF,S2_L1_VAr,S2_L1_VA,S2_L1_Watts,S2_L1_Current
,S2_L2_PF,S2_L2_VAr,S2_L2_VA,S2_L2_Watts,S2_L2_Current,S2_L3_PF,S2_L3_VAr,S2_L3_VA,S2_L3_Watts,S2_L3_Current,Main_Gen_LNVolt,Gen_LLVolt,GateWayID,ComMode
,Digital_IP,Digital_OP,S1_L1_N_Voltage,S1_L2_N_Voltage,S1_L3_N_Voltage,S1_L1_L2_Voltage,S1_L2_L3_Voltage,S1_L3_L1_Voltage,S2_L1_N_Voltage
,S2_L2_N_Voltage,S2_L3_N_Voltage,S2_L1_L2_Voltage,S2_L2_L3_Voltage,S2_L3_L1_Voltage,S1_LN_Volt,S1_LL_Volt,S2_LN_Volt,S2_LL_Volt      
  FROM #tmpDataMovement_355 '
  --WHERE Sno > 0 AND MessageInId NOT IN (SELECT MessageInId FROM Technopower_Archive.dbo.'+@ptablename+')'
  EXEC (@InsertQry)      
  SELECT @rowCount = CAST(COUNT(BoxId) AS VARCHAR(25)) FROM #tmpDataMovement_355 --WHERE Sno > 0      
        
  SELECT @endExecutionTime = GETUTCDATE();      
      
--  SET @bodytag = '<div style="font-family: Verdana; font-size: 12px;">      
--  <p><span style="color: rgb(0, 102, 153);"><strong>Dear All,</strong></span></p>      
--  <p><span style="color: rgb(0, 102, 153);"><u><em><strong>History data''s of all the devices from 355 are moved to Archive database. <font size="6" color="red">'+@rowCount+'</font> Data are successfully moved to Archive database at '+ CAST(GETDATE()
--     AS VARCHAR) +'.</strong></em></u>      
--</span></p>      
--  <table border="0" cellpadding="1" cellspacing="1" style="width: 439px; color: rgb(0, 102, 153);font-family: Verdana;">      
--  <tbody>      
--  <tr>      
--  <td align="left" nowrap="nowrap" style="font-family: Verdana; font-size: 12px;" valign="top"><strong>Details</strong></td>      
--  <td>&nbsp;</td>      
--  <td>&nbsp;</td>      
--  </tr>      
--  <tr style="font-family: Verdana; font-size: 12px;">      
--  <td align="left" valign="top">      
--  <strong>Source Database Name</strong>      
--  </td>      
--  <td align="left" valign="top">      
--  :      
--  </td>      
--  <td>      
--  Technopower      
--  </td>      
--  </tr>      
--  <tr style="font-family: Verdana; font-size: 12px;">      
--  <td align="left" valign="top">      
--  <strong>Destination Database Name</strong>      
--  </td>      
--  <td align="left" valign="top">      
--  :      
--  </td>      
--  <td>      
--  Technopower_ARCHIVE      
--  </td>      
--  </tr>      
--  <tr style="font-family: Verdana; font-size: 12px;">      
--  <td align="left" valign="top">      
--  <strong>Source Server</strong>      
--  </td>      
--  <td align="left" valign="top">      
--  :      
--  </td>      
--  <td>      
--  DB Server      
--  </td>      
--  </tr>      
--  <tr style="font-family: Verdana; font-size: 12px;">      
--  <td align="left" valign="top">      
--  <strong>Destination Server</strong>      
--  </td>      
--  <td align="left" valign="top">      
--  :      
--  </td>      
--  <td>      
--  DB Server       
--  </td>      
--  </tr>      
--  <tr style="font-family: Verdana; font-size: 12px;">      
--  <td align="left" valign="top">      
--  <strong>Execution Time (hh:mm:ss)</strong>      
--  </td>      
--  <td align="left" valign="top">      
--  :      
--  </td>      
--  <td>'+      
--  ISNULL(dbo.rvlf_fn_GetTimeFromSeconds(DATEDIFF(SECOND,@stExecutionTime,@endExecutionTime)),'-')      
--  +'</td>      
--  </tr>      
--  </tbody>      
--  </table>      
--  <hr />      
--  <p>      
--  <span style="color: rgb(0, 102, 153);"><b>Best Regards,<br />      
--  </b></span><a href="http://www.trinetrawireless.com">      
--  <img alt="trinetrawireless" src=""      
--  style="border: 0px none; width: 94px; height: 34px;" /></a></p>      
--  <p>      
--  <span style="font-size: 10px;"><span style="color: rgb(0, 102, 153);">This is a system generated mail</span><br />      
--  </span>      
--  </p>      
--  <p>      
--  <b><b>&nbsp;</b></b></p>      
--  </div>'      
      
 -- EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',      
 -- @recipients='',  
  
 -- @subject='TRINETRA | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'      
      
 -- PRINT 'Try'      
        
  UPDATE rvlfMsgInHst_Techno_355 SET IsArchived=1 WHERE MessageInID IN (SELECT MessageInID FROM #tmpDataMovement_355 WHERE Sno > 0)      
        
END TRY      
 BEGIN CATCH      
       
        
      
  DECLARE @errLine VARCHAR(10),@errMsg VARCHAR(Max)      
  SELECT @errLine = ERROR_LINE(),@errMsg = ERROR_MESSAGE()      
      
  PRINT 'CATCH - '+ CAST(@errLine AS VARCHAR) +' ,Message : '+CAST(@errMsg AS VARCHAR(max))      
      
  --SET @bodytag = '<div> Line No : '+ CAST(@errLine AS VARCHAR) +' , Message : '+CAST(@errMsg AS VARCHAR(max))+'</div>'      
  --EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',  
  --@recipients='',  
  
  --@subject='TRINETRA - ERROR | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'   
      
  END CATCH      
       
 DROP TABLE #tmpDataMovement_355      
       
SET NOCOUNT OFF      
END

 

GO


