USE [TechnoPower]
GO

/****** Object:  StoredProcedure [dbo].[rvlf_sp_AutomateDataMovement_7410_Yearly]    Script Date: 22-Nov-2023 5.16.03 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROC [dbo].[rvlf_sp_AutomateDataMovement_7410_Yearly]      
/*********************************************************************************************************      
Procedure Name : rvlf_sp_AutomateDataMovement      
Created By  :   
Created Date : 20-Nov-2023      
Description  : Data move from Live to backup database         
    
********************************************************************************************************/      
AS      
BEGIN      
SET NOCOUNT ON      
 --Data move from Pilot to Backup database [Table name : rvlfMsgInHst]      
       
 DECLARE @rowCount VARCHAR(25)      
 DECLARE @bodytag VARCHAR(MAX) = ''      
 DECLARE @stExecutionTime DATETIME      
 DECLARE @endExecutionTime DATETIME      
       
 BEGIN TRY      
       
  SELECT @stExecutionTime = GETUTCDATE();      
        
  CREATE TABLE #tmpDataMovement_7410      
  (      
   [Sno] [INT] IDENTITY(1,1) NOT NULL,      
   [MessageInID] [uniqueidentifier] NOT NULL,
	[BoxId] [varchar](15) NOT NULL,
	[OriginDateTime] [datetime] NOT NULL,
	[DateTimeReceived] [datetime] NOT NULL,
	[BoxMsgInTypeId] [tinyint] NULL,
	[CommInfo1] [varchar](15) NULL,
	[CommInfo2] [int] NULL,
	[ValidGps] [smallint] NULL,
	[Latitude] [decimal](10, 6) NULL,
	[Longitude] [decimal](10, 6) NULL,
	[Speed] [tinyint] NULL,
	[Heading] [smallint] NULL,
	[CustomProp] [varchar](2000) NULL,
	[StreetAddress] [varchar](250) NULL,
	[SequenceNum] [bigint] NULL,
	[IsArmed] [bit] NULL,
	[IsProcessed] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ControllerID] [bigint] NULL,
	[Alarm] [bit] NULL,
	[Batt_Volt] [decimal](18, 2) NULL,
	[Batt_Current] [bigint] NULL,
	[Batt_LstRreplacement] [varchar](500) NULL,
	[Chrg_Alternator] [decimal](18, 2) NULL,
	[Coolant_Temp] [smallint] NULL,
	[EngineSpeed] [int] NULL,
	[Engine_RunTime] [bigint] NULL,
	[FuelLevel] [smallint] NULL,
	[Tot_Watts] [float] NULL,
	[Tot_VA] [float] NULL,
	[Tot_VAr] [float] NULL,
	[Gen_KWh] [float] NULL,
	[Gen_KVAh] [float] NULL,
	[Gen_KVArh] [float] NULL,
	[Gen_Freq] [float] NULL,
	[Gen_AvgPF] [float] NULL,
	[Gen_L1_PF] [float] NULL,
	[Gen_L1_VAr] [float] NULL,
	[Gen_L1_VA] [float] NULL,
	[Gen_L1_Watts] [float] NULL,
	[Gen_L1_Current] [float] NULL,
	[Gen_L2_PF] [float] NULL,
	[Gen_L2_VAr] [float] NULL,
	[Gen_L2_VA] [float] NULL,
	[Gen_L2_Watts] [float] NULL,
	[Gen_L2_Current] [float] NULL,
	[Gen_L3_PF] [smallint] NULL,
	[Gen_L3_VAr] [float] NULL,
	[Gen_L3_VA] [float] NULL,
	[Gen_L3_Watts] [float] NULL,
	[Gen_L3_Current] [float] NULL,
	[Gen_LNVolt] [float] NULL,
	[Gen_LLVolt] [float] NULL,
	[NumofStarts] [int] NULL,
	[Oil_Temp] [smallint] NULL,
	[Oil_Pressure] [int] NULL,
	[GateWayID] [bigint] NULL,
	[ComMode] [nvarchar](50) NULL,
	[Digital_IP] [varchar](50) NULL,
	[Digital_OP] [varchar](50) NULL,
	[GEN_L1_N_VOLT] [float] NULL,
	[GEN_L2_N_VOLT] [float] NULL,
	[GEN_L3_N_VOLT] [float] NULL,
	[GEN_L1_L2_VOLT] [float] NULL,
	[GEN_L2_L3_VOLT] [float] NULL,
	[GEN_L1_L3_VOLT] [float] NULL,
	[GENCURRENT_L1] [float] NULL,
	[GENCURRENT_L2] [float] NULL,
	[GENCURRENT_L3] [float] NULL,
	[BatteryCharger_OP_Cur] [float] NULL,
	[Controller_Mode] [varchar](50) NULL,
	[Supervisor_State] [varchar](50) NULL,
	[Gen_Rating] [varchar](50) NULL,      
   CONSTRAINT pk_tmpDataMovement_7410_MessageInId PRIMARY KEY(Sno,MessageInID)      
  )      
        
  INSERT INTO #tmpDataMovement_7410([MessageInID],	[BoxId],[OriginDateTime],[DateTimeReceived] ,	[BoxMsgInTypeId],	[CommInfo1] ,
[CommInfo2] ,[ValidGps],[Latitude],[Longitude] ,	[Speed],	[Heading],[CustomProp] ,[StreetAddress],[SequenceNum] ,	[IsArmed] ,	[IsProcessed] ,	[IsArchived],[ControllerID],[Alarm],	[Batt_Volt],[Batt_Current] ,	[Batt_LstRreplacement],	[Chrg_Alternator],
[Coolant_Temp],[EngineSpeed],[Engine_RunTime] ,	[FuelLevel],	[Tot_Watts],	[Tot_VA],	[Tot_VAr],	[Gen_KWh],
[Gen_KVAh],	[Gen_KVArh],[Gen_Freq],	[Gen_AvgPF],	[Gen_L1_PF],	[Gen_L1_VAr],	[Gen_L1_VA],	[Gen_L1_Watts],	[Gen_L1_Current],	[Gen_L2_PF],
[Gen_L2_VAr],[Gen_L2_VA],[Gen_L2_Watts],[Gen_L2_Current],	[Gen_L3_PF],	[Gen_L3_VAr],	[Gen_L3_VA],[Gen_L3_Watts],	[Gen_L3_Current],
[Gen_LNVolt],[Gen_LLVolt],[NumofStarts],[Oil_Temp],	[Oil_Pressure] ,	[GateWayID] ,
[ComMode],[Digital_IP],	[Digital_OP],[GEN_L1_N_VOLT],	[GEN_L2_N_VOLT],	[GEN_L3_N_VOLT],	[GEN_L1_L2_VOLT],	[GEN_L2_L3_VOLT],
[GEN_L1_L3_VOLT],[GENCURRENT_L1],[GENCURRENT_L2],	[GENCURRENT_L3],	[BatteryCharger_OP_Cur],	[Controller_Mode] ,	[Supervisor_State] ,
[Gen_Rating]) 

     
  SELECT [MessageInID],	[BoxId],[OriginDateTime],[DateTimeReceived] ,	[BoxMsgInTypeId],	[CommInfo1] ,
[CommInfo2] ,[ValidGps],[Latitude],[Longitude] ,	[Speed],	[Heading],[CustomProp] ,[StreetAddress],[SequenceNum] ,	[IsArmed] ,	[IsProcessed] ,	[IsArchived],[ControllerID],[Alarm],	[Batt_Volt],[Batt_Current] ,	[Batt_LstRreplacement],	[Chrg_Alternator],
[Coolant_Temp],[EngineSpeed],[Engine_RunTime] ,	[FuelLevel],	[Tot_Watts],	[Tot_VA],	[Tot_VAr],	[Gen_KWh],
[Gen_KVAh],	[Gen_KVArh],[Gen_Freq],	[Gen_AvgPF],	[Gen_L1_PF],	[Gen_L1_VAr],	[Gen_L1_VA],	[Gen_L1_Watts],	[Gen_L1_Current],	[Gen_L2_PF],
[Gen_L2_VAr],[Gen_L2_VA],[Gen_L2_Watts],[Gen_L2_Current],	[Gen_L3_PF],	[Gen_L3_VAr],	[Gen_L3_VA],[Gen_L3_Watts],	[Gen_L3_Current],
[Gen_LNVolt],[Gen_LLVolt],[NumofStarts],[Oil_Temp],	[Oil_Pressure] ,	[GateWayID] ,
[ComMode],[Digital_IP],	[Digital_OP],[GEN_L1_N_VOLT],	[GEN_L2_N_VOLT],	[GEN_L3_N_VOLT],	[GEN_L1_L2_VOLT],	[GEN_L2_L3_VOLT],
[GEN_L1_L3_VOLT],[GENCURRENT_L1],[GENCURRENT_L2],	[GENCURRENT_L3],	[BatteryCharger_OP_Cur],	[Controller_Mode] ,	[Supervisor_State] ,
[Gen_Rating]                
  FROM rvlfMsgInHst_Techno h WHERE h.IsArchived=0     
      
  --SELECT MessageInID,BoxId,OriginDateTime,DateTimeReceived,ServiceID,BoxMsgInTypeId,BoxProtocolTypeId,CommInfo1,      
  --CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,SensorMask,CustomProp,StreetAddress,SequenceNum,IsArmed,      
  --NearestLandmark,Priority,IsNotificationSent,LandMarkID,IsProcessed,odometer,duration,StreetAddress_AR,RoadSpeedLimit,RoadType,StreetAddress_Hin      
  --FROM #tmpDataMovement_FMS WHERE Sno > 0      
      
  --SELECT * FROM FMS_ARCHIVE.dbo.rvlfMsgInHst WHERE MessageInId IN (Select MessageInId FROM #tmpDataMovement_FMS WHERE Sno > 0)      

DECLARE @ptablename VARCHAR(max) = 'rvlfMsgInHst_Techno_'+ cast(year(getdate()) as varchar(4))
Declare @sql varchar(max)
IF NOT EXISTS ( SELECT TABLE_NAME FROM Technopower_Archive.INFORMATION_SCHEMA.tables  WHERE TABLE_NAME = @ptablename )  
BEGIN   
set @sql=N'CREATE TABLE Technopower_Archive.dbo.'+@ptablename+'(
[MessageInID] [uniqueidentifier] NOT NULL,
	[BoxId] [varchar](15) NOT NULL,
	[OriginDateTime] [datetime] NOT NULL,
	[DateTimeReceived] [datetime] NOT NULL,
	[BoxMsgInTypeId] [tinyint] NULL,
	[CommInfo1] [varchar](15) NULL,
	[CommInfo2] [int] NULL,
	[ValidGps] [smallint] NULL,
	[Latitude] [decimal](10, 6) NULL,
	[Longitude] [decimal](10, 6) NULL,
	[Speed] [tinyint] NULL,
	[Heading] [smallint] NULL,
	[CustomProp] [varchar](2000) NULL,
	[StreetAddress] [varchar](250) NULL,
	[SequenceNum] [bigint] NULL,
	[IsArmed] [bit] NULL,
	[IsProcessed] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ControllerID] [bigint] NULL,
	[Alarm] [bit] NULL,
	[Batt_Volt] [decimal](18, 2) NULL,
	[Batt_Current] [bigint] NULL,
	[Batt_LstRreplacement] [varchar](500) NULL,
	[Chrg_Alternator] [decimal](18, 2) NULL,
	[Coolant_Temp] [smallint] NULL,
	[EngineSpeed] [int] NULL,
	[Engine_RunTime] [bigint] NULL,
	[FuelLevel] [smallint] NULL,
	[Tot_Watts] [float] NULL,
	[Tot_VA] [float] NULL,
	[Tot_VAr] [float] NULL,
	[Gen_KWh] [float] NULL,
	[Gen_KVAh] [float] NULL,
	[Gen_KVArh] [float] NULL,
	[Gen_Freq] [float] NULL,
	[Gen_AvgPF] [float] NULL,
	[Gen_L1_PF] [float] NULL,
	[Gen_L1_VAr] [float] NULL,
	[Gen_L1_VA] [float] NULL,
	[Gen_L1_Watts] [float] NULL,
	[Gen_L1_Current] [float] NULL,
	[Gen_L2_PF] [float] NULL,
	[Gen_L2_VAr] [float] NULL,
	[Gen_L2_VA] [float] NULL,
	[Gen_L2_Watts] [float] NULL,
	[Gen_L2_Current] [float] NULL,
	[Gen_L3_PF] [smallint] NULL,
	[Gen_L3_VAr] [float] NULL,
	[Gen_L3_VA] [float] NULL,
	[Gen_L3_Watts] [float] NULL,
	[Gen_L3_Current] [float] NULL,
	[Gen_LNVolt] [float] NULL,
	[Gen_LLVolt] [float] NULL,
	[NumofStarts] [int] NULL,
	[Oil_Temp] [smallint] NULL,
	[Oil_Pressure] [int] NULL,
	[GateWayID] [bigint] NULL,
	[ComMode] [nvarchar](50) NULL,
	[Digital_IP] [varchar](50) NULL,
	[Digital_OP] [varchar](50) NULL,
	[GEN_L1_N_VOLT] [float] NULL,
	[GEN_L2_N_VOLT] [float] NULL,
	[GEN_L3_N_VOLT] [float] NULL,
	[GEN_L1_L2_VOLT] [float] NULL,
	[GEN_L2_L3_VOLT] [float] NULL,
	[GEN_L1_L3_VOLT] [float] NULL,
	[GENCURRENT_L1] [float] NULL,
	[GENCURRENT_L2] [float] NULL,
	[GENCURRENT_L3] [float] NULL,
	[BatteryCharger_OP_Cur] [float] NULL,
	[Controller_Mode] [varchar](50) NULL,
	[Supervisor_State] [varchar](50) NULL,
	[Gen_Rating] [varchar](50) NULL,
PRIMARY KEY CLUSTERED 
(
	[MessageInID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]'
--select len(@sql),@sql
EXEC (@sql)  
END 
DECLaRE @InsertQry varchar(max)= N'INSERT INTO Technopower_Archive.dbo.'+@ptablename+'    
  ([MessageInID],[BoxId],[OriginDateTime],[DateTimeReceived],[BoxMsgInTypeId],[CommInfo1] ,
[CommInfo2] ,[ValidGps],[Latitude],[Longitude] ,[Speed],[Heading],[CustomProp],[StreetAddress],[SequenceNum],[IsArmed] ,[IsProcessed],[IsArchived],[ControllerID],[Alarm],	[Batt_Volt],[Batt_Current] ,[Batt_LstRreplacement],	[Chrg_Alternator],
[Coolant_Temp],[EngineSpeed],[Engine_RunTime] ,	[FuelLevel],[Tot_Watts],[Tot_VA],[Tot_VAr],	[Gen_KWh],
[Gen_KVAh],	[Gen_KVArh],[Gen_Freq],	[Gen_AvgPF],[Gen_L1_PF],[Gen_L1_VAr],[Gen_L1_VA],[Gen_L1_Watts],[Gen_L1_Current],[Gen_L2_PF],
[Gen_L2_VAr],[Gen_L2_VA],[Gen_L2_Watts],[Gen_L2_Current],[Gen_L3_PF],[Gen_L3_VAr],[Gen_L3_VA],[Gen_L3_Watts],[Gen_L3_Current],
[Gen_LNVolt],[Gen_LLVolt],[NumofStarts],[Oil_Temp],	[Oil_Pressure] ,[GateWayID] ,[ComMode],[Digital_IP],[Digital_OP],[GEN_L1_N_VOLT],[GEN_L2_N_VOLT],[GEN_L3_N_VOLT],[GEN_L1_L2_VOLT],[GEN_L2_L3_VOLT],[GEN_L1_L3_VOLT],[GENCURRENT_L1],[GENCURRENT_L2],[GENCURRENT_L3],	[BatteryCharger_OP_Cur],	[Controller_Mode] ,	[Supervisor_State] ,[Gen_Rating]) 

  SELECT [MessageInID],[BoxId],[OriginDateTime],[DateTimeReceived],[BoxMsgInTypeId],[CommInfo1] ,
[CommInfo2] ,[ValidGps],[Latitude],[Longitude] ,[Speed],[Heading],[CustomProp],[StreetAddress],[SequenceNum],[IsArmed] ,[IsProcessed],[IsArchived],[ControllerID],[Alarm],	[Batt_Volt],[Batt_Current] ,[Batt_LstRreplacement],	[Chrg_Alternator],
[Coolant_Temp],[EngineSpeed],[Engine_RunTime] ,	[FuelLevel],[Tot_Watts],[Tot_VA],[Tot_VAr],	[Gen_KWh],
[Gen_KVAh],	[Gen_KVArh],[Gen_Freq],	[Gen_AvgPF],[Gen_L1_PF],[Gen_L1_VAr],[Gen_L1_VA],[Gen_L1_Watts],[Gen_L1_Current],[Gen_L2_PF],
[Gen_L2_VAr],[Gen_L2_VA],[Gen_L2_Watts],[Gen_L2_Current],[Gen_L3_PF],[Gen_L3_VAr],[Gen_L3_VA],[Gen_L3_Watts],[Gen_L3_Current],
[Gen_LNVolt],[Gen_LLVolt],[NumofStarts],[Oil_Temp],	[Oil_Pressure] ,[GateWayID] ,[ComMode],[Digital_IP],[Digital_OP],[GEN_L1_N_VOLT],[GEN_L2_N_VOLT],[GEN_L3_N_VOLT],[GEN_L1_L2_VOLT],[GEN_L2_L3_VOLT],[GEN_L1_L3_VOLT],[GENCURRENT_L1],[GENCURRENT_L2],[GENCURRENT_L3],	[BatteryCharger_OP_Cur],	[Controller_Mode] ,	[Supervisor_State] ,[Gen_Rating]      
  FROM #tmpDataMovement_7410 '
  --WHERE Sno > 0 AND MessageInId NOT IN (SELECT MessageInId FROM TRINETRA_Pilot_Archive.dbo.'+@ptablename+')'
  EXEC (@InsertQry)      
  SELECT @rowCount = CAST(COUNT(BoxId) AS VARCHAR(25)) FROM #tmpDataMovement_7410 --WHERE Sno > 0      
        
  SELECT @endExecutionTime = GETUTCDATE();      
      
  SET @bodytag = '<div style="font-family: Verdana; font-size: 12px;">      
  <p><span style="color: rgb(0, 102, 153);"><strong>Dear All,</strong></span></p>      
  <p><span style="color: rgb(0, 102, 153);"><u><em><strong>History data''s of all the devices from 7410 are moved to Archive database. <font size="6" color="red">'+@rowCount+'</font> Data are successfully moved to Archive database at '+ CAST(GETDATE()
     AS VARCHAR) +'.</strong></em></u>      
</span></p>      
  <table border="0" cellpadding="1" cellspacing="1" style="width: 439px; color: rgb(0, 102, 153);font-family: Verdana;">      
  <tbody>      
  <tr>      
  <td align="left" nowrap="nowrap" style="font-family: Verdana; font-size: 12px;" valign="top"><strong>Details</strong></td>      
  <td>&nbsp;</td>      
  <td>&nbsp;</td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Source Database Name</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  Technopower      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Destination Database Name</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  Technopower_ARCHIVE      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Source Server</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  DB Server      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Destination Server</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  DB Server       
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Execution Time (hh:mm:ss)</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>'+      
  ISNULL(dbo.rvlf_fn_GetTimeFromSeconds(DATEDIFF(SECOND,@stExecutionTime,@endExecutionTime)),'-')      
  +'</td>      
  </tr>      
  </tbody>      
  </table>      
  <hr />      
  <p>      
  <span style="color: rgb(0, 102, 153);"><b>Best Regards,<br />      
  </b></span><a href="http://www.trinetrawireless.com">      
  <img alt="trinetrawireless" src=""      
  style="border: 0px none; width: 94px; height: 34px;" /></a></p>      
  <p>      
  <span style="font-size: 10px;"><span style="color: rgb(0, 102, 153);">This is a system generated mail</span><br />      
  </span>      
  </p>      
  <p>      
  <b><b>&nbsp;</b></b></p>      
  </div>'      
      
 -- EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',      
 -- @recipients='',  
  
 -- @subject='TRINETRA | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'      
      
 -- PRINT 'Try'      
        
  UPDATE rvlfMsgInHst_Techno SET IsArchived=1 WHERE MessageInID IN (SELECT MessageInID FROM #tmpDataMovement_7410 WHERE Sno > 0)      
        
END TRY      
 BEGIN CATCH      
       
        
      
  DECLARE @errLine VARCHAR(10),@errMsg VARCHAR(Max)      
  SELECT @errLine = ERROR_LINE(),@errMsg = ERROR_MESSAGE()      
      
  PRINT 'CATCH - '+ CAST(@errLine AS VARCHAR) +' ,Message : '+CAST(@errMsg AS VARCHAR(max))      
      
  --SET @bodytag = '<div> Line No : '+ CAST(@errLine AS VARCHAR) +' , Message : '+CAST(@errMsg AS VARCHAR(max))+'</div>'      
  --EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',  
  --@recipients='',  
  
  --@subject='TRINETRA - ERROR | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'   
      
  END CATCH      
       
 DROP TABLE #tmpDataMovement_7410      
       
SET NOCOUNT OFF      
END

 

GO


