USE [TechnoPower]
GO

/****** Object:  StoredProcedure [dbo].[rvlf_sp_AutomateDataMovement_alarms_Yearly]    Script Date: 22-Nov-2023 5.16.09 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROC [dbo].[rvlf_sp_AutomateDataMovement_alarms_Yearly]      
/*********************************************************************************************************      
       
Created By  :  Gopal.R 
Created Date : 20-Nov-2023      
Description  : Data move from Live to Archive database         
    
********************************************************************************************************/      
AS      
BEGIN      
SET NOCOUNT ON      
 --Data move from Pilot to Backup database [Table name : rvlfAlarm]      
       
 DECLARE @rowCount VARCHAR(25)      
 DECLARE @bodytag VARCHAR(MAX) = ''      
 DECLARE @stExecutionTime DATETIME      
 DECLARE @endExecutionTime DATETIME      
       
 BEGIN TRY      
       
  SELECT @stExecutionTime = GETUTCDATE();      
        
  CREATE TABLE #tmpDataMovement_alarm      
  (      
   [Sno] [INT] IDENTITY(1,1) NOT NULL,      
   [AlarmId] [bigint] NOT NULL,
	[DateTimeCreated] [datetime] NOT NULL,
	[BoxId] [varchar](25) NULL,
	[AlarmType] [bigint] NOT NULL,
	[AlarmLevelId] [smallint] NOT NULL,
	[DateTimeAccepted] [datetime] NULL,
	[AcceptedBy] [bigint] NULL,
	[DateTimeClosed] [datetime] NULL,
	[ClosedBy] [bigint] NULL,
	[Description] [varchar](250) NOT NULL,
	[Lat] [decimal](10, 6) NOT NULL,
	[Long] [decimal](10, 6) NOT NULL,
	[StreetAddress] [varchar](250) NULL,
	[IsClosed] [tinyint] NULL,
	[DriverId] [bigint] NULL,
	[Comments] [nvarchar](150) NULL,
	[StreetAddress_Ar] [nvarchar](250) NULL,
	[StreetAddress_Hin] [nvarchar](250) NULL,
	[CustomProp] [varchar](1000) NULL,
	[MessageInID] [uniqueidentifier] NULL,
	[ControllerID] [varchar](25) NULL,
	[AlarmRepeatFlag] [tinyint] NULL,
	[DCSIM] [tinyint] NULL,
	[Rootcause] [nvarchar](500) NULL,
	[Correctiveaction] [nvarchar](max) NULL,
	[IsAcknowledged] [bit] NULL,
	[Acknowledgedby] [int] NULL,      
   CONSTRAINT pk_tmpDataMovement_alarms_AlarmId PRIMARY KEY(Sno,AlarmId)      
  )      
        
  INSERT INTO #tmpDataMovement_alarm(AlarmId,DateTimeCreated,BoxId,AlarmType,AlarmLevelId,DateTimeAccepted,AcceptedBy,DateTimeClosed,ClosedBy,Description,Lat
,Long,StreetAddress,IsClosed,DriverId,Comments,StreetAddress_Ar,StreetAddress_Hin,CustomProp,MessageInID,ControllerID,AlarmRepeatFlag
,DCSIM,Rootcause,Correctiveaction,IsAcknowledged,Acknowledgedby) 
	
     
  SELECT AlarmId,DateTimeCreated,BoxId,AlarmType,AlarmLevelId,DateTimeAccepted,AcceptedBy,DateTimeClosed,ClosedBy,Description,Lat
,Long,StreetAddress,IsClosed,DriverId,Comments,StreetAddress_Ar,StreetAddress_Hin,CustomProp,MessageInID,ControllerID,AlarmRepeatFlag
,DCSIM,Rootcause,Correctiveaction,IsAcknowledged,Acknowledgedby                
  FROM rvlfAlarm h WHERE h.IsArchived=0     
      
  --SELECT MessageInID,BoxId,OriginDateTime,DateTimeReceived,ServiceID,BoxMsgInTypeId,BoxProtocolTypeId,CommInfo1,      
  --CommInfo2,ValidGps,Latitude,Longitude,Speed,Heading,SensorMask,CustomProp,StreetAddress,SequenceNum,IsArmed,      
  --NearestLandmark,Priority,IsNotificationSent,LandMarkID,IsProcessed,odometer,duration,StreetAddress_AR,RoadSpeedLimit,RoadType,StreetAddress_Hin      
  --FROM #tmpDataMovement_FMS WHERE Sno > 0      
      
  --SELECT * FROM FMS_ARCHIVE.dbo.rvlfMsgInHst WHERE MessageInId IN (Select MessageInId FROM #tmpDataMovement_FMS WHERE Sno > 0)      

DECLARE @ptablename VARCHAR(max) = 'rvlfAlarm_Techno_'+ cast(year(getdate()) as varchar(4))
Declare @sql varchar(max)
IF NOT EXISTS ( SELECT TABLE_NAME FROM Technopower_Archive.INFORMATION_SCHEMA.tables  WHERE TABLE_NAME = @ptablename )  
BEGIN   
set @sql=N'CREATE TABLE Technopower_Archive.dbo.'+@ptablename+'(
[AlarmId] [bigint] NOT NULL,
	[DateTimeCreated] [datetime] NOT NULL,
	[BoxId] [varchar](25) NULL,
	[AlarmType] [bigint] NOT NULL,
	[AlarmLevelId] [smallint] NOT NULL,
	[DateTimeAccepted] [datetime] NULL,
	[AcceptedBy] [bigint] NULL,
	[DateTimeClosed] [datetime] NULL,
	[ClosedBy] [bigint] NULL,
	[Description] [varchar](250) NOT NULL,
	[Lat] [decimal](10, 6) NOT NULL,
	[Long] [decimal](10, 6) NOT NULL,
	[StreetAddress] [varchar](250) NULL,
	[IsClosed] [tinyint] NULL,
	[DriverId] [bigint] NULL,
	[Comments] [nvarchar](150) NULL,
	[StreetAddress_Ar] [nvarchar](250) NULL,
	[StreetAddress_Hin] [nvarchar](250) NULL,
	[CustomProp] [varchar](1000) NULL,
	[MessageInID] [uniqueidentifier] NULL,
	[ControllerID] [varchar](25) NULL,
	[AlarmRepeatFlag] [tinyint] NULL,
	[DCSIM] [tinyint] NULL,
	[Rootcause] [nvarchar](500) NULL,
	[Correctiveaction] [nvarchar](max) NULL,
	[IsAcknowledged] [bit] NULL,
	[Acknowledgedby] [int] NULL, 
	[IsArchived] [bit],
PRIMARY KEY CLUSTERED 
(
	[AlarmId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]'
--select len(@sql),@sql
EXEC (@sql)  
END 
DECLaRE @InsertQry varchar(max)= N'INSERT INTO Technopower_Archive.dbo.'+@ptablename+'    
  (AlarmId,DateTimeCreated,BoxId,AlarmType,AlarmLevelId,DateTimeAccepted,AcceptedBy,DateTimeClosed,ClosedBy,Description,Lat
,Long,StreetAddress,IsClosed,DriverId,Comments,StreetAddress_Ar,StreetAddress_Hin,CustomProp,MessageInID,ControllerID,AlarmRepeatFlag
,DCSIM,Rootcause,Correctiveaction,IsAcknowledged,Acknowledgedby) 

  SELECT AlarmId,DateTimeCreated,BoxId,AlarmType,AlarmLevelId,DateTimeAccepted,AcceptedBy,DateTimeClosed,ClosedBy,Description,Lat
,Long,StreetAddress,IsClosed,DriverId,Comments,StreetAddress_Ar,StreetAddress_Hin,CustomProp,MessageInID,ControllerID,AlarmRepeatFlag
,DCSIM,Rootcause,Correctiveaction,IsAcknowledged,Acknowledgedby      
  FROM #tmpDataMovement_alarm'
  --WHERE Sno > 0 AND MessageInId NOT IN (SELECT MessageInId FROM TRINETRA_Pilot_Archive.dbo.'+@ptablename+')'
  EXEC (@InsertQry)      
  SELECT @rowCount = CAST(COUNT(BoxId) AS VARCHAR(25)) FROM #tmpDataMovement_alarm --WHERE Sno > 0      
        
  SELECT @endExecutionTime = GETUTCDATE();      
      
  SET @bodytag = '<div style="font-family: Verdana; font-size: 12px;">      
  <p><span style="color: rgb(0, 102, 153);"><strong>Dear All,</strong></span></p>      
  <p><span style="color: rgb(0, 102, 153);"><u><em><strong>Alarm data of all the devices are moved to Archive database. <font size="6" color="red">'+@rowCount+'</font> Data are successfully moved to Archive database at '+ CAST(GETDATE()
     AS VARCHAR) +'.</strong></em></u>      
</span></p>      
  <table border="0" cellpadding="1" cellspacing="1" style="width: 439px; color: rgb(0, 102, 153);font-family: Verdana;">      
  <tbody>      
  <tr>      
  <td align="left" nowrap="nowrap" style="font-family: Verdana; font-size: 12px;" valign="top"><strong>Details</strong></td>      
  <td>&nbsp;</td>      
  <td>&nbsp;</td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">  
  <strong>Source Database Name</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  Technopower      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Destination Database Name</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  Technopower_ARCHIVE      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Source Server</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  DB Server      
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Destination Server</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>      
  DB Server       
  </td>      
  </tr>      
  <tr style="font-family: Verdana; font-size: 12px;">      
  <td align="left" valign="top">      
  <strong>Execution Time (hh:mm:ss)</strong>      
  </td>      
  <td align="left" valign="top">      
  :      
  </td>      
  <td>'+      
  ISNULL(dbo.rvlf_fn_GetTimeFromSeconds(DATEDIFF(SECOND,@stExecutionTime,@endExecutionTime)),'-')      
  +'</td>      
  </tr>      
  </tbody>      
  </table>      
  <hr />      
  <p>      
  <span style="color: rgb(0, 102, 153);"><b>Best Regards,<br />      
  </b></span><a href="http://www.trinetrawireless.com">      
  <img alt="trinetrawireless" src=""      
  style="border: 0px none; width: 94px; height: 34px;" /></a></p>      
  <p>      
  <span style="font-size: 10px;"><span style="color: rgb(0, 102, 153);">This is a system generated mail</span><br />      
  </span>      
  </p>      
  <p>      
  <b><b>&nbsp;</b></b></p>      
  </div>'      
      
 -- EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',      
 -- @recipients='',  
  
 -- @subject='TRINETRA | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'      
      
 -- PRINT 'Try'      
        
  UPDATE rvlfAlarm SET IsArchived=1 WHERE AlarmId IN (SELECT AlarmId FROM #tmpDataMovement_alarm WHERE Sno > 0)      
        
END TRY      
 BEGIN CATCH      
       
        
      
  DECLARE @errLine VARCHAR(10),@errMsg VARCHAR(Max)      
  SELECT @errLine = ERROR_LINE(),@errMsg = ERROR_MESSAGE()      
      
  PRINT 'CATCH - '+ CAST(@errLine AS VARCHAR) +' ,Message : '+CAST(@errMsg AS VARCHAR(max))      
      
  --SET @bodytag = '<div> Line No : '+ CAST(@errLine AS VARCHAR) +' , Message : '+CAST(@errMsg AS VARCHAR(max))+'</div>'      
  --EXEC msdb.dbo.sp_send_dbmail @profile_name='TRINETRA',  
  --@recipients='',  
  
  --@subject='TRINETRA - ERROR | Reg : Automate Data Backup',@body= @bodytag,@body_format = 'HTML'   
      
  END CATCH      
       
 DROP TABLE #tmpDataMovement_alarm      
       
SET NOCOUNT OFF      
END

 

GO


